// Copyright (c) 2017 Nuxi, https://nuxi.nl/
//
// This file is distributed under a 2-clause BSD license.
// See the LICENSE file for details.

#include <uv.h>

#include "uv_impl.h"

const char *uv_err_name(int err) {
  switch (err) {
    case UV_E2BIG:
      return "E2BIG";
    case UV_EACCES:
      return "EACCES";
    case UV_EADDRINUSE:
      return "EADDRINUSE";
    case UV_EADDRNOTAVAIL:
      return "EADDRNOTAVAIL";
    case UV_EAFNOSUPPORT:
      return "EAFNOSUPPORT";
    case UV_EAGAIN:
      return "EAGAIN";
    case UV_EAI_ADDRFAMILY:
      return "EAI_ADDRFAMILY";
    case UV_EAI_AGAIN:
      return "EAI_AGAIN";
    case UV_EAI_BADFLAGS:
      return "EAI_BADFLAGS";
    case UV_EAI_BADHINTS:
      return "EAI_BADHINTS";
    case UV_EAI_CANCELED:
      return "EAI_CANCELED";
    case UV_EAI_FAIL:
      return "EAI_FAIL";
    case UV_EAI_FAMILY:
      return "EAI_FAMILY";
    case UV_EAI_MEMORY:
      return "EAI_MEMORY";
    case UV_EAI_NODATA:
      return "EAI_NODATA";
    case UV_EAI_NONAME:
      return "EAI_NONAME";
    case UV_EAI_OVERFLOW:
      return "EAI_OVERFLOW";
    case UV_EAI_PROTOCOL:
      return "EAI_PROTOCOL";
    case UV_EAI_SERVICE:
      return "EAI_SERVICE";
    case UV_EAI_SOCKTYPE:
      return "EAI_SOCKTYPE";
    case UV_EALREADY:
      return "EALREADY";
    case UV_EBADF:
      return "EBADF";
    case UV_EBUSY:
      return "EBUSY";
    case UV_ECANCELED:
      return "ECANCELED";
    case UV_ECHARSET:
      return "ECHARSET";
    case UV_ECONNABORTED:
      return "ECONNABORTED";
    case UV_ECONNREFUSED:
      return "ECONNREFUSED";
    case UV_ECONNRESET:
      return "ECONNRESET";
    case UV_EDESTADDRREQ:
      return "EDESTADDRREQ";
    case UV_EEXIST:
      return "EEXIST";
    case UV_EFAULT:
      return "EFAULT";
    case UV_EFBIG:
      return "EFBIG";
    case UV_EHOSTUNREACH:
      return "EHOSTUNREACH";
    case UV_EINTR:
      return "EINTR";
    case UV_EINVAL:
      return "EINVAL";
    case UV_EIO:
      return "EIO";
    case UV_EISCONN:
      return "EISCONN";
    case UV_EISDIR:
      return "EISDIR";
    case UV_ELOOP:
      return "ELOOP";
    case UV_EMFILE:
      return "EMFILE";
    case UV_EMLINK:
      return "EMLINK";
    case UV_EMSGSIZE:
      return "EMSGSIZE";
    case UV_ENAMETOOLONG:
      return "ENAMETOOLONG";
    case UV_ENETDOWN:
      return "ENETDOWN";
    case UV_ENETUNREACH:
      return "ENETUNREACH";
    case UV_ENFILE:
      return "ENFILE";
    case UV_ENOBUFS:
      return "ENOBUFS";
    case UV_ENODEV:
      return "ENODEV";
    case UV_ENOENT:
      return "ENOENT";
    case UV_ENOMEM:
      return "ENOMEM";
    case UV_ENONET:
      return "ENONET";
    case UV_ENOPROTOOPT:
      return "ENOPROTOOPT";
    case UV_ENOSPC:
      return "ENOSPC";
    case UV_ENOSYS:
      return "ENOSYS";
    case UV_ENOTCONN:
      return "ENOTCONN";
    case UV_ENOTDIR:
      return "ENOTDIR";
    case UV_ENOTEMPTY:
      return "ENOTEMPTY";
    case UV_ENOTSOCK:
      return "ENOTSOCK";
    case UV_ENOTSUP:
      return "ENOTSUP";
    case UV_ENXIO:
      return "ENXIO";
    case UV_EOF:
      return "EOF";
    case UV_EPERM:
      return "EPERM";
    case UV_EPIPE:
      return "EPIPE";
    case UV_EPROTO:
      return "EPROTO";
    case UV_EPROTONOSUPPORT:
      return "EPROTONOSUPPORT";
    case UV_EPROTOTYPE:
      return "EPROTOTYPE";
    case UV_ERANGE:
      return "ERANGE";
    case UV_EROFS:
      return "EROFS";
    case UV_ESHUTDOWN:
      return "ESHUTDOWN";
    case UV_ESPIPE:
      return "ESPIPE";
    case UV_ESRCH:
      return "ESRCH";
    case UV_ETIMEDOUT:
      return "ETIMEDOUT";
    case UV_ETXTBSY:
      return "ETXTBSY";
    case UV_EXDEV:
      return "EXDEV";
    case UV_UNKNOWN:
      return "UNKNOWN";
    default:
      return __uv_strerror_unknown(err);
  }
}
